// サンプルデータセットのダウンロード
use https://www.stata-press.com/data/r17/gsem_lca1
describe

// 推定
gsem (accident play insurance stock <- ), logit lclass(C 2)

// モデル診断
estat lcgof
estimates store twoclass
gsem (accident play insurance stock <- ), logit lclass(C 1)
estimates store oneclass
estat lcgof
gsem (accident play insurance stock <- ), logit lclass(C 3)
estimates store threeclass
estat lcgof
estimates stats oneclass twoclass threeclass

// 予測
gsem (accident play insurance stock <- ), logit lclass(C 2)
estat lcmean
estat lcprob
predict classpost*, classposteriorpr
list in 1
generate expclass = 1 + (classpost2>0.5)
tabulate expclass
margins, predict(classpr class(1)) predict(classpr class(2))
marginsplot, xlabel(, angle(vertical))
estat lcmean
marginsplot

// 潜在プロファイルモデル
use https://www.stata-press.com/data/r17/gsem_lca2, clear
describe
gsem (glucose insulin sspg <- _cons), lclass(C 2)

// 共分散のあるモデル
gsem (glucose insulin sspg <- _cons), lclass(C 3) lcinvariant(none) covstructure(e._OEn, unstructured)
predict cpost*, classposteriorpr
egen max = rowmax(cpost*)
generate predclass = 1 if cpost1==max
replace predclass = 2 if cpost2==max
replace predclass = 3 if cpost3==max
tabulate cclass predclass, col
